
            ===========================================
                          S I M I L A R
                    Logic Design and Simulation 
            ===========================================
                          powered by 
               Hardware-Software-Design, Hagenberg
            ===========================================

-----------------------------------------------------------------------

Release Notes 3.4.0
-  Bug fixes:	
-  New feature: 
				- Help system uses a PDF viewer.
-  Known Issues:
				- Element properties: 2-3 Tab/Shift-Tab key strokes are  
				  erroneously consumed.
				- Help texts are missing for few gates. 
				- German UI is to be done.


-----------------------------------------------------------------------

Release Notes 3.3.0
-  Bug fixes:	
				- Property section of slicers is displayed correctly.
				- F1 button activates help even an editor has the keyboard
				  focus.
-  New feature: 
				- KV-Diagram: Ordering of prime imlicants improved.
				- Circuit Truthtable: Windows sizing improved.
-  Known Issues:
				- Element properties: 2-3 Tab/Shift-Tab key strokes are  
				  erroneously consumed.
				- Help texts are missing for few gates. 
				- German UI is to be done.

-----------------------------------------------------------------------

Release Notes 3.2.3
-  Bug fixes:	
			    - Circuit Simulator: "Play" after "Pause" simulates one
				  step only. Now simulation starts immediately.
-  Known Issues:
				- Element properties: 2-3 Tab/Shift-Tab key strokes are  
				  erroneously consumed.
				- Help texts are missing for some gates. 

-----------------------------------------------------------------------

Release Notes 3.2.1
-  Bug fixes:	
			    - Closing an empty truth table window crashed Similar.
				- CPU: Registerfile: Register values are not updated
				  after an active reset.
-  Known Issues:
				- Element properties: 2-3 Tab/Shift-Tab key strokes are  
				  erroneously consumed.
				- Circuit Simulator: "Play" after "Pause" simulates one
				  step only.

-----------------------------------------------------------------------

Release Notes 3.2.0
-  Bug fixes:	
			    - Labels of input/output/monitor gates may not be set to 
				  an empty string anymore.								
-  Known Issues:
				- Element properties: 2-3 Tab/Shift-Tab key strokes are  
				  erroneously consumed.
				- Circuit Simulator: "Play" after "Pause" simulates one
				  step only.

-----------------------------------------------------------------------

Release Notes 3.1.4
-  Bug fixes:	
			    - FSM Editor: The "Delete button" deletes items independent
				  of current editing activity.	             
                - FSM-Editor: Minor improvements to achieve a more stable 
				  operation.
                - Truth Table: Bug in "Undo Changes" fixed. 
                - LUT gates created from an FSM window are now common LUT       
				  gates (I/O can be changed). However, changing the I/O 
				  resets its truthtable.
				- Metastability menu: Wrong format of values fixed.		
				
-  Changed Features:
                - FSM-Editor: Deleting a transition or state now resets
                  current I/O and state assignments, respectively.
				- Truth Table: The Espresso minimization to Product-of-Sums
				  is temporarily inactivated due to wrong results in special
				  cases.
				- Element properties: Tab/Shift-Tab functionality is 
				  provisionally implemented (see Known Issues).
				  Using the Return/Enter key also activates the next input 
				  item.
-  Known Issues:
				- Element properties: 2-3 Tab/Shift-Tab key strokes are  
				  erroneously consumed.
				- Circuit Simulator: "Play" after "Pause" simulates one
				  step only.

-----------------------------------------------------------------------

Release Notes 3.1.3
-  Bug fixes:	
			    - LUT gate and Truthtable Window: Special characters in port 
				  names which triggered unexpected behaviour are 
			      now ignored.
				- Truthtable Window: When editing a table, a mouse click in 
				  the blank area of its header is ignored.
			    - Truthtable Window: Empty tables may not be saved when 
				  closing the window.
			    - Text: "!!" now allowed in arbitrary test fields.
				- Text: Line breaks get restored from saved Similar files.
				- Loading a file of wrong type is rejected for FSMs, 
				  truthtables and circuits.
				- FSM Editor: "Create Circuit" during circuit simulation is 
				  inactivated.

-  Changed Features:
                - No restrictions in length of names of circuits any more.
				  However, labels of input-, output- and monitor-gates are 
				  still restricted to 15 characters.
				- Due to restictions and performance issues of the unerlying 
				  Qt table model, truth tables and LUT gates are restricted 
				  to 24 inputs.
				- Incompletely defined FSMs cannot be exported preventing  
				  invalid KISS files now.

-  Known Issues:
                - I/O of LUT gates created from an FSM window cannot be
				  changed.
				- FSM Editor: Moving a label may crash Similar.
				- Element properties: Tab/Shift-Tab are to be implemented.
				- FSM Editor: Inconsistent behaviour of the Delete button.
				- Circuit Simulator: "Play" after "Pause" simulates one
				  step only.
				- Truth Tables: "Undo Changes" produces invalid ports
				  in special cases.
				- Metastability menu: Mean is assigned wrong values 
				  ("1,000E+01", ...).

                  				
-----------------------------------------------------------------------

Release Notes 3.1.2
-  New Feature: - Strg-0 (Crtl-0) resets zoom factor of scene to 100%.
-  Bug fixes:	- Snap-to-Grid at margins corrected.
                - Consumation of events are reorganized.
				- When pasting a group of Input-Gates, Output-Gates and/or
				  Monitor-Gates, the correct offset for placement is
				  applied.
				  

-----------------------------------------------------------------------

Release Notes 3.1.1
-  Changed Features:
                - Length of labels are limited to 15 charachters
-  Bug fixes:   - A group of Input-Gates, Output-Gates and/or
				  Monitor-Gates could not be moved around without 
				  restrictions.
-  Known Issus: - When pasting a group of Input-Gates, Output-Gates and/or
				  Monitor-Gates, a wrong offset for placement may
				  be applied.
                
-----------------------------------------------------------------------

Release Notes 3.1.0
-  Bug Fixes    - Deleting a gate now deletes connected wires with
                  zero lenght.  
                - Pasting a (meanwhile) deleted circuit does not cause
                  Similar to stop execution.				
				- Switching between Dark- and Ligthmode for 
				  Windows 11 fixed.
				- Select All (Ctrl-A, Strg-A) now selects all 
				  elements - even those which are placed outside of 
				  the drawing area.


-----------------------------------------------------------------------

Release Notes 3.0.5
-  Bug Fixes    - Artifacts from moving subcircuits in scenes (> 250%)
                  are fixed.
				- Properties Window: Alignment of text in drop-downs of 
				  comboboxes fixed for dark mode.

-----------------------------------------------------------------------

Release Notes 3.0.3
 
-  New Features - Entities and architectures remember position and size
                  of HDL windows when closed and reopened.
-  Bug Fixes    - Minor bug fixes in the HDL simulator:
                  - An initial illegal name of an architecture may 
				    be changed.
				  - Size of HDL gates is adapted to connect to wires when
				    a port ist placed on an existing wire.

-----------------------------------------------------------------------


Release Notes 3.0.2

-  Bug Fixes    - Various bug fixes in the HDL simulator

-----------------------------------------------------------------------

Release Notes 3.0.1

-  Bug Fixes    - Qt 6.5.0
                - Some minor HDL bugs are fixed.
				- HDL Simulation: User inputs which are set prior 
				  a simulation run (or in a paused simulation run)
				  are propagated into first delta cycle of simulation
                - HDL Window: Drivers of arrays are printed correctly 
                              during simulation (Command: dr)

-----------------------------------------------------------------------

Release Notes 3.0.0

-  New Features - An Alpha version of HDL gates is introduced. An HDL 
                  gate is defined by means of an entity/architecture 
				  using VHDL syntax.
				  				  
				  Similar only provides a small subset of VHDL:
				  
				  Entity:
				     Port types: std_ulogic 
                                         std_ulogic_vector (constrained array type)                                      										  
                     Port modes: in, out	
                     Not implemented:					  
				         Generics and entity bodies 
					     Ports with unconstrained array types
					  
			      Architecture:				                     
			         Available:				 
					    Builtin types (bit, bit_vector, std_ulogic, std_ulogic_vector,
						               integer, integer_vector, time);
						Type declaration: enumeration types	
			            Subtype declarations
                        Attributes: 'left, 'right, 'low, 'high, 'lenght, 'ascending
                                    'event, 'range, 'reverse_range									
						Constant, variable, signal, shared variable
						Aggregates and slices for builtin vectors (including other)
					    Process statement with/without sensitivity list
						Sequential statements
						Function declaration and funtion call
				    
					Not available:
					    Strings
					    Type declarations for arrays and structures 
						Procedure statement

-  German versions of menus and dialogs are not yet available.	

-----------------------------------------------------------------------

Release Notes 2.8.7

-  Bug Fixes    - Circuit Editor: Another issue in moving gates 
                                  and wires is fixed.	
                - Circuit Editor: Changing the direction of I/O-Ports
                                  and Button-Gates without selected gates
                                  does not clear the property window 
								  any more.		
                - Circuit Editor: Monitor gates are updated when bitwidth
                                  of wirenet changes.				

-  German versions of menus and dialogs are temporarily not available.								  
								  
-----------------------------------------------------------------------

Release Notes 2.8.6

-  Bug Fixes    - Circuit Editor: Menu entry "Duplicate Circuits" is fully 
                                  functional now.
                - Circuit Editor: Named Wires: Larger and lower case of 
				                  letters may be changed immediately.
                - Circuit Editor: Moving gates and wires is aborted if an error
                                  has occured. Proceeding the move operation had 
								  occasionally crashed Similar.								  
-  Changed Feature:
                -  Circuit Editor: Selecting a HexValue gate does not focus
				   on the value editor automatically any more, but allows 
				   moving and deleting the gate as usual.
				   To change its value, the editor in the property toolbox 
				   has to be activated by an explicit left button click.		
				  
-  New Feature: - FSM Files: *.sfsm files can be opened from Windows
				  File Exporer by double clicking it, provided Similar was 
				  installed. Otherwise *.sfsm files may be opened 
				  using "Open With" and selecting Similar.exe.		
				  
-  German versions of menus and dialogs are temporarily not available.
				  
-----------------------------------------------------------------------

Release Notes 2.8.5

-  The mayor release 3.0 is still being prepared. Internal
   reorganisations and refactorings are in progress. 
-  German versions of menus and dialogs are temporarily not available.

-  New Features - FSM Window: Double clicking a text item  selects limiting
                  '<' and '>', too. Hence changing the default values is
				  eased.
				- FSM Files: *.sfsm files can be opened from Windows
				  File Exporer using "Open With" and selecting Similar.exe.
				  
-----------------------------------------------------------------------

Release Notes 2.8.4

-  End date for usage is set to 2022-12-31.
-  The mayor release 3.0 is being prepared. Therefore some internal
   reorganisations and refactoring are in progress. 
-  German versions of menus and dialogs are temporarily not available.

-----------------------------------------------------------------------

Release Notes 2.7.5

-  Windows 11: Minor issues resolved.

-----------------------------------------------------------------------

Release Notes 2.5.1, 2.5.2

-  Minor Bug Fixes

-----------------------------------------------------------------------

Release Notes 2.5.0


-  New Features - CPU-Window: Computer components and instruction set
                  architecture are saved in circuit files. 
				- CPU-Window: No more erroneus highlighted lines in 
				  assembler listings while simulating a computer
				  architecture.

-  Minor Bug Fixes				
				  
-----------------------------------------------------------------------

Release Notes 2.4.7

-  New Features - CPU-Window: More than one gate of a cpu architecture 
                  can be set or unset being a cpu component. 
				- Circuit Editor: Left selection of an item without any 
				  modifier key deselects all currently selected items.
                  
-----------------------------------------------------------------------

Release Notes 2.4.6

-  Bug Fix      - Truthtable: Extracting a truthtable of circuits produced
                  wrong switching functions (all outputs were set to '0'),
				  in version 2.4.5 after optimizing Simular's simulation 
				  cycle. The special issue on simulating all input values
				  automatically is reimplemented now.
				  
-----------------------------------------------------------------------

Release Notes 2.4.5

-  New Features - Waveform Window: Order of ports are saved in circuit
                  file.	   
 
-----------------------------------------------------------------------

Release Notes 2.4.4

-  Bug Fixes	- Registerfile-Editor works for signed, unsigned and 
                  hexadecimal values now.
				  Registerfile-Editor: Displayed values are updated
				  during simulation.				   
-  Minor Bug fixes  

-----------------------------------------------------------------------

Release Notes 2.4.3
                 
- New Feature	- Simulation Engine: User inputs are postponed
                  to next simulation cycle. Wires connected to
				  input gates are not updated immediately. Therewith
				  simulation results remain valid, even if multithreading
				  is utilised.
- Bug Fixes	    - Waveform Window: After a simulation restart waveforms
                  are displayed corrtectly now.                   			  
                  				  				
-----------------------------------------------------------------------

Release Notes 2.4.2
                 
- New Feature   - Circuit files are exchangeable between the 64-Bit and 
                  32-Bit releases of Similar now. 
				  Existing circuit files should be opened and saved with 
				  the appropriate 32-Bit or 64-Bit release. 
				  The newly created file is accepted by both releases.
- Bug Fixes	    - Extract Truthtable: After sorting ports a further 
                  reordering is achievable.			  
                  				  				
-----------------------------------------------------------------------

Release Notes 2.4.1
                 
- Bug Fixes		- Wrong simulation outputs of LUT-Gates defined with 
                  minimized truthtables have been fixed.
				- 7-Seg-Gates are included in save/load operations.

-----------------------------------------------------------------------

Release Notes 2.4.0

- New Feature	- Circuit Editor: A PushButton is introduced. While
                  being pushed it outputs a '1'. In idle mode a '0'
                  is produced.                  
- Bug Fixes		- Some small issues are fixed.

-----------------------------------------------------------------------

Release Notes 2.3.3

- New Feature	- Circuit Editor: Newly inserted gates get their
                  properties from the displayed element properties if
                  those are applicable. 
                - Circuits may be locked for editing. This feature is 
                  activated/deactivated using the edit menu or by means
                  of Ctrl-L.				  
- Bug Fixes		- Fix that a cpus's register file is not part of a cpu 
                  anymore after saving and reloading.

-----------------------------------------------------------------------

Release Notes 2.3.0

- New Feature	- File format of circuits changed!
				  IMPORTANT: The new file format is not compatible
				  with previous versions of Similar. Trying to open
				  a new file with an older version of Similar crashes
				  the application.
			    - Circuit may be locked to prevent them from being 
                  changed erroneously.
				- Circuit Editor: Strg-Z/Ctrl-Z performs an undo now.
				- Names of scir files may include umlauts and blanks 
				  to be opened with a doubleclick from the Windows File 
				  Explorer.
				- Circuit-Editor: The editor for labels for inputs, 
				  outputs, and monitors are activated only when inserting 
				  a new gate. Selecting a existing gate does not 
				  activate the editor anymore. 
				  Thus the delete key now works also for inputs, outputs 
				  and monitors, too.	
				- Circuit Editor: Move an item without previously selecting
				  it. Just grap and move. 				
- Bug Fixes		- Fix that circuits are marked as modified right after 
                  loading.
                - Fix obsolete warnings when changing the order of ports
				  of a circuit which is instantiated within a parent
				  circuit.	
				- Fix scaling factors are not saved with circuits. 
				  Circuits were shifted and displayed with standard scale 
				  when reloaded.
				- CPU Window: Fix failed gnu assembling when source file 
                  does not end with a newline character after ".end".
				- Circuit Editor: Fix Ctrl-MouseLeftButton does not toggle 
				  selection.                 				

-----------------------------------------------------------------------

Release Notes 2.2.0

- New Feature	- Similar no is built upon Qt 6.1.
                - Textblocks are now provided to enrich circuits with 
                  comments.
				- VHDL export now includes register files.
				- VHDL export now exports entity declarations for ALU,
				  RegisterFile, RAM, ROM, Shifter, ...
				- VHDL export now exports a whole circuit with all its 
				  entities and architectures into a common directory.
				- VHDL export automatically excludes unconnected wires 
				  and ports, respectively. 
- Bug Fixes
				- Fix wrong color of wires after changing dark mode 
				  without restarting.
				- Fix names of wires not being unique. Case-insensivity 
				  comparision is applied.
				- Fix values of Hex-Value gate when bit length is changed.
				- CPU: Fix contents of memory not changed after reloading
				  and restarting simulation. During a simulation run memories
				  should not be changeable.
				- Export VHDL: Fix wrong VHDL slices when using slicer 
				  gates in series.
				- Export VHDL: Fix erroneus default value for multiplexing
				  vectors.
				  
-----------------------------------------------------------------------

Release Notes 2.1.2

- Bug Fixes   	- Combinational Gates: under certain circumstances the 
                  displayed and implemented values of delays and rejection 
				  limits did not match.
				- ROM- and RAM-Gates: changing the alignment and endianess
				  using the propertiy combo boxes did not change the gate's 
				  behaviour after a simulation run has been started and 
				  has been finished.
				  
-----------------------------------------------------------------------

Release Notes 2.1.1

- New Feature   - Similar now provides a dark mode (yet experimental).
       

-----------------------------------------------------------------------

Release Notes 2.0.0 

- New Feature   - Similar is now available in a German edition
                  (currently with the exception of help data).     
- New Feature   - added CPU Window which allows to design and simulate 
                  cpu architectures (ARM v4, RISC-V).
                  + A cpu circuit has to contain at least
                    a register (= program counter) and may
                    contain a register file, ROM (instruction
                    memory) and RAM (instruction or data memory).
                  + Register, RAM, ROM, Register are defined
                    as cpu components by means of the context menu.
                  + assembling and loading of program and data 
                    for ARMv4 or RISC-V architectures
                  + Simulation allows single stepping the program 
                    by incrementing the circuit's program counter 
                  + Observable and editable registerfile: 
                    Double clicking the registerfile opens a
                    viewing and editing window.
- New Features  - Truthtable with multiple outputs: 
                  added functionality to synthesize and autolayout.
                - Truthtable: Columns are resized when an input is
                  renamed.
                - KV-Diagramm: Area of algebraic expressions is
                  scrollable now.
             
- Bug Fix       - FSM-Editor: Menus remain deactivated until an FSM
                  is created or loaded. Defining states or transitions
                  without creating an FSM before does not crash Similar 
                  any more.
                - Circuit Editor: Imprecisely specified bounding boxes
                  caused artifacts when moving gates. Now, a more accurate
                  definition of bounding boxes prevents this.                    

=======================================================================

Release Notes 1.9.8 

- New Feature   - Look-Up-Tables: Synthesis and layout of circuits 
                  with multiple output gates are introduced.
- Bug fix       - Circuit editor: ctrl+leftbutton allows selecting
                  mulitple items.
                - Circuit editor: Rubberband opens after deleting 
                  an item (pressing the ESC key ist not necessary
                  anymore).
Changed Feature - Circuit editor: ESC key returns to selection mode 
                  and shows select cursor. Wire mode is cancelled.

------------------------------------------------------------------------
                 
Release Notes 1.9.7 

- Bug fix       - Truthtable extension now preserves I/O
                  functionality. If possible, DC values may
                  be inserted.
 
------------------------------------------------------------------------
 
Release Notes 1.9.6 

- New Feature   - Registerfile provides an asynchronous reset port.
- Bug fix       - Circuit-Editors: Properties of multiple selected
                  ROMs, RAMs, Registers and Registerfiles are 
                  setable in common.
                - Wave window correctly displays "noData" when 
                  opened after simulation time 0 and data is not
                  available any more.
- Known Issues  - Printing under Qt6 doesn't find fonts and cannot
                  print any character correctly.
 
------------------------------------------------------------------------
 
Release Notes 1.9.5

- New Feature   - Similar for Qt 6 is available for Ubuntu 20.04.1.

- Bug fix       - FSM-Editor: Labels of transitions do not 
                  disappear if a transition control point is
                  moved.
                - FSM-Editor: A transition can be selected even
                  if its controlpoint lies within the bounding
                  boxes of other transitions.
                - FSM-Editor: Window remains in full size mode
                  when a dialog window is cancelled.
                - Circuit-Editor: Multiple input gates, output gates,
                  and monitor gates can be selected to change 
                  their orientation.
                - Circuit-Editor: Seven-Segment gates are can be 
                  saved and loaded now.
                - Circuit-Editor: Minimization menus for LuT gates
                  are extended and improved.
                - Circuit-Editor: Slicer gates: An issue on undoing
                  a mirror operation is repaired.                

------------------------------------------------------------------------

Release Notes 1.9.4

- New Feature:  - Circuit Editor: Inputgates: Shift-Right-Click 
                  allows to set all bits to the selected value.
                - Circuit Editor: Inputgates: Shift-Left-Click 
                  toggles all bits - not only one.
                - FSM-Editor: Label and controlpoint get 
                  highlighted when the associated transition 
                  is selected. 
- Bug fix:      - FSM Editor: Fixed issue that cursor buttons 
                  move the whole diagram while labels of states or
                  transitions are edited.
                - FSM-Editor: Menu actions are disabled while
                  inserting states and transitions and while
                  editing labels to avoid inconsistent system
                  states.                 
                - FSM-Editor: Selected transitions are  
                  repainted correctly.
                - FSM-Editor: FSM is deleted when FSMWindow is   
                  closed. When closing the MainWindow Similar
                  does not ask again whether the FSM shall be
                  saved.
                - FSM-Editor: Control points of new FSMs or loaded 
                  FSMs are displayed according to menu settings.
                - Circuit-Editor: Menu actions are disabled while
                  inserting gates, wires and circuits and while
                  editing labels to avoid inconsistent system
                  states.
                - Circuit-Editor: Input-, Output, Monitor-Gate:
                  User modified positions of gate labels are saved
                  and restored now.
                - Circuit-Editor: Seven-Segment gates can be saved 
                  and loaded.              
- Known Bug:    - FSM-Editor: A control point with position within
                  the area of a second transition can not be moved.
 
-------------------------------------------------------------

Release Notes 1.9.3

                Compiled for latest version of Qt (6.0.0 ) 
- New Feature:  - FSM Editor: New menu "View" allows to hide
                  and to display control items for transitions.
- Bug fix:      - FSM Editor allows correct selection of 
                  transitions and control items.
- Known Bug:    - FSM-Editor: Selected transitions are not repainted 
                  correctly - some pixels at both ends are not
                  cleared appropriately.
                 
-------------------------------------------------------------

Release Notes 1.9.2

                Compiled for latest version of Qt (6.0.0 RC-2) 
- New Feature:  - New sequential gate: Registerfile for CPUs
                  architectures.
                - Circuit TruthTable/LuT Gate: Sorting of ports 
                  introduced.
                - Property Boxes consider different and equal 
                  values of multiple selected gates.
                - FSM files (*.sfsm) are now registered for
                  similar.exe (Qt6 only).
- Bug fix:      - After an undo operation  the system returns 
                  to the selection cursor.
                - FSM editor allows to open a new FSM after
                  drawing a large machine.

-------------------------------------------------------------

Release Notes 1.9.1

                Compiled for latest version of Qt (6.0.Beta5) 
- New Feature:  Minimizations derived from KV-Diagrams 
                  can be synthesized to logic gates.               
- Bug fix:      Bugs in Undo-System fixed:
                - Deleted I/O Gates are not listed as variables 
                - Undo-Systeme: Repeated deleting of gates and  
                  undoing does not crash Similar anymore.              
                Truthtable Window: Menu activation and 
                  deactivation fixed to guide user and
                  prevent unallowed operations.

-------------------------------------------------------------

Release Notes 1.9.0

                Compiled for latest version of Qt (6.0.0 Beta 2)            
- New Feature:  KV-Diagrams are introduced: LuT-Gates and 
                Truthtables with up to 4 input variables 
                can be analyzed and minimized.                
                
- Bug fix:      Minor bugs fixed 

--------------------------------------------------------------

Release Notes 1.8.1

- Minor bug fixes  
- Minor changes to compile using QT 6.0.0 alpha  
                
--------------------------------------------------------------

Release Notes 1.8.0

- New Feature:  Compiled for latest version of Qt (15.1)
                A simulator for FSMs is introduced.
                Logic synthesis for state transition function 
                and output function is a new feature. After maually
                adding flipflops for states an FSM can be simulated 
                on gate level (as a circuit). 
                
- Bug fix:      Minor bugs fixed 

--------------------------------------------------------------
 
Release Notes 1.7.0

- New Feature:  FSM Editior for Moore and Mealy machines:
                State-, Input- and Output-Assignment allow
                dual and one-hot values.
                Creation of LuT-Gates for state transition
                and output calculation.
- Bug fix:      Minor bugs fixed 

--------------------------------------------------------------

Release Notes 1.6.5

- New Feature:  New Flipflop: DFF with asynchronous reset 
                and SET.
- Bug fix:      Minor bugs fixed                 

--------------------------------------------------------------

Release Notes 1.6.4

- Bug fix:      Minor bugs fixed 

--------------------------------------------------------------

Release Notes 1.6.3

- Bug fix:      Deleted gates caused an error when saving 
                a circuit to file. 
- Changed GUI:  Exporting a VHDL testbench is available from  
                Project Menu. It is not necessary to change 
                Settings any more.                

--------------------------------------------------------------

Release Notes 1.6.2

- New Feature:  VHDL Export for ALU, Shifter, ROM, RAM (E/A)
                and Lookup-Table (process)
- Bug fix       Deleted gates are not considered for building
                simulation and VHDL models any more. 

--------------------------------------------------------------

Release Notes 1.6.1

- New Feature:  Config files are saved in user's home directory:
                - Similar.cfg stores settings chosen in Project 
                  menu   
                - ISA.json defines Instruction Set Architectures
                  for CPUs and allows to define and adapt 
                  ISAs and corresponding tools and parameters.

--------------------------------------------------------------

Release Notes 1.6.0

- New Feature:  Similar allows to model CPU architectures:                 
                A new CPU window allows assembling ARM v4
                assembler and loading instructions and data
                into memory components.
                Users may specify program counter, instruction
                memory and data memory with context menus of 
                RAM, ROM and register gates.
                               
--------------------------------------------------------------

Release Notes 1.5.6

- Bug fix:      Slicergate: Dialog box for defining slices is
                now positioned below the gate.
- Changed Feature: Position of labels of Input-/Output-/
                Monitorgates are preserved if changed by user.              

--------------------------------------------------------------

Release Notes 1.5.5

- New Feature:  The Label of Input/Output/Monitor gates changes 
                its position automatically when data bits or
                base of gate changes.
- Changed Feature: "Center Circuit on Open" is now located
                in Menu "View" and is not part of "Settings" 
                any more.
- Bug fix:      Disappearing wires on second monitor: Instances
                of circuits get original position of ports when
                loading from a´.scir file. Positions are not
                recalculated even if font sizes differ.
- Bug fix:      Constant gates snap to grid correctly.
                IMPORTANT: Constants may need to be reconnected
                           in existing circuits!
- New Feature:  Selecting an Input/Output/Monitor gate automatically
                puts focus on the name property and shows a
                blinking caret.

--------------------------------------------------------------

Release Notes 1.5.4

- New Feature:  Based upon latest Qt 14.1 
- New Feature:  Waveform Window: 
                Full functionality for multi-bit values:
                - Define order
                - Expand/Collapse values,
                - Define Radix (by means of context menu).

- New Feature:  DPI-Awareness of fonts improved. 
- New Feature:  Help for gate introduced.

- Bug fix:      LuT gate may be simulated now event though
                is truthtable has not been edited. 
- Bug fix:      All combos of property boxes display two
                digits if necessary.
- Bug fix:      Content of RAM/RAM not longer cleared after
                an undo operation.

--------------------------------------------------------------

Release Notes 1.5.3

- New Feature:  Timescale in Waveform Window available.
- New Feature:  ALU-Gate introduced. 
                However, Help is not implemented yet .
                All arithmetic data is of type SIGNED!
                Currently available Ops:
                   0000 AND    1000 ADD
                   0001 XOR    1001 SUB
                   0010 ORR    1010 RSB
                   0011 NOT    1011 MUL
                   0100 BIC    1100 INC
                   0101        1101 DEC
                   0110        1110
                   0111        1111
                   
- New Feature:  Shiftergate fully implemented.
                Available Commands (cmd):
                   00 Logical Shift Left
                   01 Logical Shift Right
                   10 Arithmetic Shift Right
                   11 Rotate Right
                   
- New Feature:  Seven-Segment-Gates may be driven with
                4-Bit binary numbers.
- New Feature:  Gray colored Slicergates and SevenSegmentgates
                illustrate unconnected input ports.

--------------------------------------------------------------

Release Notes 1.5.2

- New Feature:  RAM/ROM/LuT are saved in scir file by default;
                Saving in separate files is available in 
                settings menu. 
- New Feature:  Undo of copy/cut/paste introduced.
- New Feature:  WaveWindow: Order of signals can be defined.
- New Feature:  New checkbox in settings menu: 
                Center circuits on open view. 
- Bug fix:      A specific error during inserting wires caused  
                items to be unselectable.  
- Bug fix:      Waveform displays correct time scale even 
                if waveform window is opened during paused 
                simulation.
                
--------------------------------------------------------------

Release Notes 1.5.1
- Bug Fix:      Size of drawing area extended from 2000x2000
                to 5000x5000 points again.
                
--------------------------------------------------------------

Release Notes 1.5.0
- New Feature:  A new type of gates is introduced: Lut-Gates
                implement truth tables (LuT: Look-Up-Table).
                A LuT-Gate may be created manually, from a 
                circuit's behavior or read in from a
                file (*.esp).
- New Feature:  Undoing includes changes of object properties.
- New Feature:  Changing "Ticks per Second" during simulation 
                stops simulation and resets Simulation time 
                to ensure consistent data in waveform windows.  
                
- Bug fix:      Some issues concerning dpi awareness are
                fixed.
- Bug fix:      Undo action with a 7-Seg-Gate involved had 
                stopped Similar.
- Bug fix:      Erroneous actions are now excluded from undo
                history. Undoing an action which caused an error 
                does not crash any more.
                
- Open Issue:   Moving elements to a position outside of the 
                drawing area make them inaccessible.
                
--------------------------------------------------------------

Release Notes 1.4.0 
- Simular is build with Qt 5.14
- New Feature: Undo of actions while editing a circuit
               now possible.
- New Feature: Context menu in circuits' tab allows
               to duplicate circuits.
- New Feature: Similar does not create unnecessary copies 
               of circuit "main" any more.
- Bug fix:     Labels and Text are appropriately sized 
               on HD Monitors now.
- Bug fix:     Moving a large amount of items does not crash
               Similar in very special situations any more.
    
--------------------------------------------------------------

Release Notes 1.3.5 
- Changed File Menu: 
         - Saving all circuits is now default:
           SaveAll and SaveAllAs. 
           SaveAs saves a single circuit only.
         - Printing of single circuits added.

--------------------------------------------------------------

Release Notes 1.3.4 
- Workaround: Qt's font scaling shifts text position.
                             
--------------------------------------------------------------

Release Notes 1.3.3 
- Bug fix: Selection of gates stacked one another 
           now possible.
- Bug fix: Moving a connected port upon another 
           connected port signals an error now.
          
--------------------------------------------------------------

Release Notes 1.3.2 
- Bug fix: Opening an ill-formated *.scir file does 
       not stop Similar any more. 
- Bug fix: Scene offsets are now saved correctly.        
          
--------------------------------------------------------------

Release Notes 1.3.1 
- Bug fix: Stepping down in hierarchy in simulation 
       mode and changing input values cancels value
       update after stepping upwards.       
          
--------------------------------------------------------------

Release Notes 1.3.0 
- New: Waveform Window for tracing simulation runs.
- New: Input/Output/Miscellaneous: Tristate Buffer.
- New: Project->Settings: Defining delays is now 
       independent from viewing and controlling 
       simulation time.
        
--------------------------------------------------------------

Release Notes 1.2.2 
- New: Config file Similar.cfg now located in 
  user's home directory.
- Bug Fix: Starting Similar by double clicking
  a data file (*.scir) displays circuit at the
  correct position.

--------------------------------------------------------------

Release Notes 1.2.1 
- Bug Fix: Similar did not minimize truthtables if
  started from shortcuts.  

--------------------------------------------------------------

Release Notes 1.2.0
- New Feature: Minimize Truthtable with Espresso

--------------------------------------------------------------

Release Notes 1.1.0
- New Feature: Synthesize twolevel circuits (PoS and SoP)
  
--------------------------------------------------------------

Release Notes 1.0.6
- Update size of monitor gates in circuit instances 
- Copy: Only copied item are selected after paste.

--------------------------------------------------------------

Release Notes 1.0.5 
- Slicer Labels: Labels show indices now 'downto'.
- Slicer allow single slice.
- Slicer Bug fixed : Connecting a signal to different 
  slices does not generated a cycle any more.
- ROM/RAM can be viewed/edited during simuation.
- Switching between viewed circuits: Screen positions
  of circuits are remembered.
- Inserting/Deleting a monitor does not change a circuits
  interface any more. Thus instances of this circuit 
  are not deleted any more.
- Some smaller bugs fixed.

--------------------------------------------------------------

Release Notes 1.0.4
- Drawing subcircuit gates now calculates port positions
  and gates' width based upon length of labels.
  
--------------------------------------------------------------
  
Release Notes 1.0.3
- Bug fix of 1.0.2: After loading an hierarchical design, saving
  a subcircuit overwrites the top level circuit. Save-As
  was not an issue.

--------------------------------------------------------------
  
Release Notes 1.0.2
- First release for Ubuntu 18.04.2 LTS.

--------------------------------------------------------------

Release Notes 1.0.1
- First Release available on www.similar.at

--------------------------------------------------------------